--- /dev/null	2012-08-18 10:37:10.000000000 +0000
+++ new/usr/src/uts/common/inet/dccp/dccp_opt_data.c	2012-08-18 10:37:10.404969938 +0000
@@ -0,0 +1,327 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License (the "License").
+ * You may not use this file except in compliance with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+
+/*
+ * Copyright 2010 Sun Microsystems, Inc.  All rights reserved.
+ * Use is subject to license terms.
+ */
+
+/*
+ * Copyright 2012 David Hoeppner.  All rights reserved.
+ */
+
+/*
+ * This file contains functions related to getting and setting options
+ * thought the getsockopt and setsockopt socket functions.
+ */
+
+#include <sys/types.h>
+#include <sys/stream.h>
+#define	_SUN_TPI_VERSION 2
+#include <sys/tihdr.h>
+#include <sys/xti_xtiopt.h>
+#include <sys/xti_inet.h>
+#include <sys/policy.h>
+
+#include <inet/common.h>
+#include <inet/dccp_impl.h>
+#include <inet/ip.h>
+#include <inet/optcom.h>
+#include <netinet/ip.h>
+
+#include <sys/cmn_err.h>
+
+static int dccp_opt_default(queue_t *, int, int, uchar_t *);
+
+/*
+ * Supported options.
+ */
+opdes_t dccp_opt_arr[] = {
+{ SO_DEBUG, SOL_SOCKET, OA_RW, OA_RW, OP_NP, 0, sizeof (int), 0 },
+}; 
+
+/*
+ * Supported levels.
+ */
+optlevel_t dccp_valid_levels_arr[] = {
+	SOL_SOCKET,
+};
+
+#define	DCCP_OPT_ARR_CNT	A_CNT(dccp_opt_arr)
+#define	DCCP_VALID_LEVELS_CNT	A_CNT(dccp_valid_levels_arr)
+
+uint_t dccp_max_optsize;
+
+/*
+ * Options database object.
+ */
+optdb_obj_t dccp_opt_obj = {
+	dccp_opt_default,
+	dccp_tpi_opt_get,
+	dccp_tpi_opt_set,
+	DCCP_OPT_ARR_CNT,
+	dccp_opt_arr,
+	DCCP_VALID_LEVELS_CNT,
+	dccp_valid_levels_arr,
+};
+
+/*
+ * Default value for certain options.
+ */
+int
+dccp_opt_default(queue_t *q, int level, int name, uchar_t *ptr)
+{
+	dccp_stack_t	*dccps = Q_TO_DCCP(q)->dccp_dccps;
+	int32_t		*il = (int32_t *)ptr;
+
+	return (sizeof (int));
+}
+
+int
+dccp_opt_get(conn_t *connp, int level, int name, uchar_t *ptr)
+{
+	dccp_t		*dccp = connp->conn_dccp;
+	conn_opt_arg_t	coas;
+	int		*i1 = (int *)ptr;
+	int		retval;
+
+	coas.coa_connp = connp;
+	coas.coa_ixa = connp->conn_ixa;
+	coas.coa_ipp = &connp->conn_xmit_ipp;
+	coas.coa_ancillary = B_FALSE;
+	coas.coa_changed = 0;
+
+	switch (level) {
+	case SOL_SOCKET:
+		break;
+	case IPPROTO_DCCP:
+		switch (name) {
+		case DCCP_NOTIFY_THRESHOLD:
+			*i1 = dccp->dccp_first_timer_threshold;
+			return (sizeof (int));
+		case DCCP_ABORT_THRESHOLD:
+			*i1 = dccp->dccp_second_timer_threshold;
+			return (sizeof (int));
+		case DCCP_CONN_NOTIFY_THRESHOLD:
+			*i1 = dccp->dccp_first_ctimer_threshold;
+			return (sizeof (int));
+		case DCCP_CONN_ABORT_THRESHOLD:
+			*i1 = dccp->dccp_second_ctimer_threshold;
+			return (sizeof (int));
+		case DCCP_KEEPALIVE_THRESHOLD:
+			*i1 = dccp->dccp_ka_interval;
+			return (sizeof (int));
+		case DCCP_KEEPINTVL:
+			*i1 = dccp->dccp_ka_rinterval / 1000;
+			return (sizeof (int));
+		}
+		break;
+	case IPPROTO_IP:
+		break;
+	case IPPROTO_IPV6:
+		break;
+	}
+
+	mutex_enter(&connp->conn_lock);
+	retval = conn_opt_get(&coas, level, name, ptr);
+	mutex_exit(&connp->conn_lock);
+
+	return (retval);
+}
+
+/* ARGSUSED */
+int
+dccp_opt_set(conn_t *connp, uint_t optset_context, int level, int name,
+    uint_t inlen, uchar_t *invalp, uint_t *outlenp, uchar_t *outvalp,
+    void *thisdg_attrs, cred_t *cr)
+{
+	dccp_t		*dccp = connp->conn_dccp;
+	dccp_stack_t	*dccps = dccp->dccp_dccps;
+	conn_opt_arg_t	coas;
+	uint32_t	val = *((uint32_t *)invalp);
+	int		*i1 = (int *)invalp;
+	boolean_t	onoff = (*i1 == 0) ? B_FALSE : B_TRUE;
+	boolean_t	checkonly = B_FALSE;
+	int		error;
+
+	coas.coa_connp = connp;
+	coas.coa_ixa = connp->conn_ixa;
+	coas.coa_ipp = &connp->conn_xmit_ipp;
+	coas.coa_ancillary = B_FALSE;
+	coas.coa_changed = 0;
+
+	switch (optset_context) {
+	case SETFN_OPTCOM_CHECKONLY:
+		checkonly = B_TRUE;
+		if (inlen = 0) {
+			*outlenp = 0;
+			return (0);
+		}
+		break;
+	case SETFN_OPTCOM_NEGOTIATE:
+		break;
+	case SETFN_UD_NEGOTIATE:
+	case SETFN_CONN_NEGOTIATE:
+		break;
+	default:
+		/*
+		 * We should never get here.
+		 */
+		*outlenp = 0;
+		return (EINVAL);
+	}
+
+	ASSERT((optset_context != SETFN_OPTCOM_CHECKONLY) ||
+	    (optset_context == SETFN_OPTCOM_CHECKONLY && inlen != 0));
+
+	/*
+	 * No ancillary data should be sent down.
+	 */
+	ASSERT(thisdg_attrs == NULL);
+
+	switch (level) {
+	case SOL_SOCKET:
+		switch (name) {
+		case SO_KEEPALIVE:
+			if (checkonly) {
+				/* Check only case */
+				break;
+			}
+
+			if (!onoff) {
+				if (connp->conn_keepalive) {
+					if (dccp->dccp_ka_tid != 0) {
+						(void) DCCP_TIMER_CANCEL(dccp,
+						    dccp->dccp_ka_tid);
+						dccp->dccp_ka_tid = 0;
+					}
+					connp->conn_keepalive = 0;
+				}
+				break;
+			}
+
+			if (!connp->conn_keepalive) {
+				/* Crank up the keepalive timer */
+				dccp->dccp_ka_last_intrvl = 0;
+				dccp->dccp_ka_tid = DCCP_TIMER(dccp,
+				    dccp_keepalive_timer, dccp->dccp_ka_interval);
+				connp->conn_keepalive = 1;
+			}
+			break;
+		}
+		break;
+	case IPPROTO_DCCP:
+		switch (name) {
+		case DCCP_NOTIFY_THRESHOLD:
+			if (!checkonly)
+				dccp->dccp_first_timer_threshold = *i1;
+			break;
+		case DCCP_ABORT_THRESHOLD:
+			if (!checkonly)
+				dccp->dccp_second_timer_threshold = *i1;
+		case DCCP_CONN_NOTIFY_THRESHOLD:
+			if (!checkonly)
+				dccp->dccp_first_ctimer_threshold = *i1;
+			break;
+		case DCCP_CONN_ABORT_THRESHOLD:
+			if (!checkonly)
+				dccp->dccp_second_ctimer_threshold = *i1;
+			break;
+		case DCCP_KEEPIDLE:
+			*i1 *= 1000;
+			/* FALLTHRU */
+		case DCCP_KEEPALIVE_THRESHOLD:
+			if (checkonly)
+				break;
+
+			if (*i1 < dccps->dccps_keepalive_interval_low ||
+			    *i1 > dccps->dccps_keepalive_interval_high) {
+				*outlenp = 0;
+				return (EINVAL);
+			}
+
+			if (*i1 != dccp->dccp_ka_interval) {
+				dccp->dccp_ka_interval = *i1;
+
+				if (dccp->dccp_ka_tid != 0) {
+					ASSERT(connp->conn_keepalive);
+					(void) DCCP_TIMER_CANCEL(dccp,
+					    dccp->dccp_ka_tid);
+					dccp->dccp_ka_last_intrvl = 0;
+					dccp->dccp_ka_tid = DCCP_TIMER(dccp,
+					    dccp_keepalive_timer,
+					    dccp->dccp_ka_interval);
+				}
+			}
+			break;
+		}
+		break;
+	case IPPROTO_IP:
+		break;
+	case IPPROTO_IPV6:
+		break;
+	}
+
+	error = conn_opt_set(&coas, level, name, inlen, invalp,
+	    B_FALSE, cr);
+	if (error !=0) {
+		*outlenp = 0;
+		return (error);
+	}
+
+	/*
+	 * Common case of OK return with outval same as inval.
+	 */
+	if (invalp != outvalp) {
+		(void) bcopy(invalp, outvalp, inlen);
+	}
+	*outlenp = inlen;
+
+	if (coas.coa_changed && COA_HEADER_CHANGED) {
+		/* If we are connected we rebuilt the headers */
+		if (!IN6_IS_ADDR_UNSPECIFIED(&connp->conn_faddr_v6) &&
+		    !IN6_IS_ADDR_V4MAPPED_ANY(&connp->conn_faddr_v6)) {
+			error = dccp_build_hdrs(dccp);
+			if (error != 0) {
+				return (error);
+			}
+		}
+	}
+
+	if (coas.coa_changed & COA_ROUTE_CHANGED) {
+		in6_addr_t	nexthop;
+
+		ip_attr_nexthop(&connp->conn_xmit_ipp, connp->conn_ixa,
+		    &connp->conn_faddr_v6, &nexthop);
+
+		if (!IN6_IS_ADDR_UNSPECIFIED(&connp->conn_faddr_v6) &&
+		    !IN6_IS_ADDR_V4MAPPED_ANY(&connp->conn_faddr_v6)) {
+			(void) ip_attr_connect(connp, connp->conn_ixa,
+			    &connp->conn_laddr_v6, &connp->conn_faddr_v6,
+			    &nexthop, connp->conn_fport, NULL, NULL,
+			    IPDF_VERIFY_DST);
+		}
+	}
+
+	/* XXX */
+
+	return (0);
+}
--- /dev/null	2012-08-18 10:37:10.000000000 +0000
+++ new/usr/src/uts/common/inet/dccp/dccp_options.c	2012-08-18 10:37:10.530253402 +0000
@@ -0,0 +1,336 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2012 David Hoeppner. All rights reserved.
+ */
+
+#include <sys/types.h> 
+#include <sys/stream.h> 
+#include <sys/debug.h> 
+#include <sys/cmn_err.h>
+
+#include <inet/dccp_impl.h>
+#include <inet/dccp_stack.h>
+
+/*
+ * This file contains functions to parse and process DCCP options.
+ */
+
+
+/*
+ * Parse the options in a DCCP header.
+ */
+int
+dccp_parse_options(dccp_t *dccp, dccpha_t *dccpha)
+{
+	uchar_t		*end;
+	uchar_t		*up;
+	uint8_t		dccp_type;
+	uint32_t	option_value;
+	uint8_t		option_type;
+	uint8_t		option_length;
+	int		len;
+	int		i;
+	uchar_t		*value;
+	boolean_t	mandatory = B_FALSE;
+	int		error;
+
+	cmn_err(CE_NOTE, "dccp_features.c: dccp_parse_options");
+
+	dccp_type = dccpha->dha_type;
+
+	up = (uchar_t *)dccpha;
+	end = up + DCCP_HDR_LENGTH(dccpha);
+	up += 20;
+
+	while (up != end) {
+		option_length = 0;
+		option_type = *up++;
+
+		if (option_type > 31) {
+			if (up == end) {
+				goto length_error;
+			}
+
+			option_length = *up++;
+			if (option_length < 2) {
+				goto length_error;
+			}
+
+			option_length -= 2;
+			value = up;
+
+			up += option_length;
+
+			/* Ignore options with greater length then header */
+			if (up > end) {
+				goto length_error;
+			}
+		} else {
+			value = up;
+		}
+
+		/* Single byte unknow option */
+		if (option_type >= 3 && option_type <=31) {
+			if (mandatory) {
+				error = DCCP_RESET_MANDATORY_ERROR;
+			} else {
+				error = DCCP_RESET_OPTION_ERROR;
+			}
+
+			dccp->dccp_reset_code = error;
+			/*
+			 * this should be correct:
+			 * dccp->dccp_reset_data[0] = option_type;
+			 * dccp->dccp_reset_data[1] = value[0];
+			 *
+			 * error in the test suit?
+			 */
+			dccp->dccp_reset_data[0] = value[0];
+			dccp->dccp_reset_data[1] = 0;
+			dccp->dccp_reset_data[2] = 0;
+
+			return (-1);
+		}
+
+		if (option_type >= 45 && option_type <=127)
+			break;
+
+
+		switch (option_type) {
+		case DCCP_OPTION_PADDING:
+			cmn_err(CE_NOTE, "PADDING");
+			break;
+		case DCCP_OPTION_MANDATORY:
+			cmn_err(CE_NOTE, "MANDATORY");
+			if (mandatory)
+				goto option_error;
+
+			if (dccp_type != DCCP_PKT_DATA)
+				mandatory = B_TRUE;
+			break;
+		case DCCP_OPTION_SLOW_RECEIVER:
+			cmn_err(CE_NOTE, "SLOW RECEIVER");
+			break;
+		case DCCP_OPTION_CHANGE_L:
+		case DCCP_OPTION_CONFIRM_L:
+		case DCCP_OPTION_CHANGE_R:
+		case DCCP_OPTION_CONFIRM_R:
+			if (dccp_type == DCCP_PACKET_DATA)
+				break;
+
+			if (option_length == 0)
+				goto option_error;
+
+			error = dccp_parse_feature(dccp, option_type, option_length,
+			    value, mandatory);
+			if (error != 0)
+				goto feature_error;
+
+			break;
+		case DCCP_OPTION_INIT_COOKIE:
+			cmn_err(CE_NOTE, "INIT COOKIE");
+			break;
+		case DCCP_OPTION_NDP_COUNT:
+			cmn_err(CE_NOTE, "NDP COUNT");
+			if (option_length > 6)
+				goto option_error;
+			break;
+		case DCCP_OPTION_ACK_VECTOR_1:
+			cmn_err(CE_NOTE, "ACK VECTOR 1");
+			break;
+		case DCCP_OPTION_ACK_VECTOR_2:
+			cmn_err(CE_NOTE, "ACK VECTOR 2");
+			break;
+		case DCCP_OPTION_DATA_DROPPED:
+			cmn_err(CE_NOTE, "DATA DROPPED");
+			break;
+		case DCCP_OPTION_TIMESTAMP:
+			cmn_err(CE_NOTE, "TIMESTAMP");
+			if (option_length != 4)
+				goto option_error;
+
+			option_value = BE32_TO_U32(value);
+			if (option_value == 0) {
+				cmn_err(CE_NOTE, "Zero timestamp");
+				break;
+			}
+
+			dccp->dccp_timestamp_echo = ntohs(option_value);
+			dccp->dccp_timestamp = TICK_TO_MSEC(LBOLT_FASTPATH);
+			break;
+		case DCCP_OPTION_TIMESTAMP_ECHO:
+			cmn_err(CE_NOTE, "TIMESTAMP ECHO");
+			if (option_length != 4 && option_length != 6 &&
+			    option_length != 8) {
+				goto option_error;
+			}
+
+			option_value = BE32_TO_U32(value);
+
+			option_length -= 4;
+			break;
+		case DCCP_OPTION_ELAPSED_TIME:
+			cmn_err(CE_NOTE, "ELAPSES TIME");
+			switch (option_length) {
+			case 2:
+				break;
+			case 4:
+				break;
+			default:
+				goto option_error;
+			}
+			break;
+		case DCCP_OPTION_DATA_CHECKSUM:
+			cmn_err(CE_NOTE, "DATA CHECKSUM");
+			break;
+
+		default:
+			cmn_err(CE_NOTE, "unknow option");
+			break;
+		}
+
+		if (option_type != DCCP_OPTION_MANDATORY) {
+			mandatory = B_FALSE;
+		}
+	}
+
+	if (mandatory)
+		goto option_error;
+
+length_error:
+	return (0);
+
+option_error:
+	if (mandatory) {
+		error = DCCP_RESET_MANDATORY_ERROR;
+	} else {
+		error = DCCP_RESET_OPTION_ERROR;
+	}
+
+	cmn_err(CE_NOTE, "setting error code");
+
+feature_error:
+	dccp->dccp_reset_code = error;
+	dccp->dccp_reset_data[0] = option_type;
+	dccp->dccp_reset_data[1] = option_length > 0 ? value[0] : 0;
+	dccp->dccp_reset_data[2] = option_length > 1 ? value[1] : 0;
+
+	return (-1);
+}
+
+int
+dccp_process_options(dccp_t *dccp, dccpha_t *dccpha)
+{
+	int	error;
+
+	cmn_err(CE_NOTE, "dccp_features.c: dccp_process_features");
+
+	error = dccp_parse_options(dccp, dccpha);
+
+	return (error);
+}
+
+int
+dccp_generate_options(dccp_t *dccp, void **opt, size_t *opt_len)
+{
+	dccp_feature_t	*feature = NULL;
+	uint8_t		buf[1024];	/* XXX */
+	uint8_t		option_type;
+	uint_t		len = 0;
+	uint_t		total_len = 0;
+	void		*options = NULL;
+	int		rest;
+
+	cmn_err(CE_NOTE, "dccp_features.c: dccp_generate_options");
+
+	for (feature = list_head(&dccp->dccp_features); feature;
+	    feature = list_next(&dccp->dccp_features, feature)) {
+		if (feature->df_option == DCCP_OPTION_CHANGE_L) {
+			option_type = DCCP_OPTION_CONFIRM_R;
+		} else {
+			option_type = DCCP_OPTION_CONFIRM_L;
+		}
+/*
+		if (feature->df_mandatory == B_TRUE) {
+			buf[len] = DCCP_OPTION_MANDATORY;
+			len++;
+		}
+*/
+		if (feature->df_type == DCCP_FEATURE_CCID) {
+			cmn_err(CE_NOTE, "FOUND DCCP_FEATURE_CCID");
+
+			buf[len] = option_type;
+			len++;
+			buf[len] = 4;
+			len++;
+			buf[len] = DCCP_FEATURE_CCID;
+			len++;
+			buf[len] = 2;
+			len++;
+		}
+
+		if (feature->df_type == DCCP_FEATURE_ALLOW_SHORT_SEQNOS) {
+			buf[len] = option_type;
+			len++;
+			buf[len] = 4;
+			len++;
+			buf[len] = feature->df_type;
+			len++;
+			buf[len] = 0;
+			len++;
+		}
+
+		if (feature->df_type == DCCP_FEATURE_ECN_INCAPABLE) {
+			buf[len] = option_type;
+			len++;
+			buf[len] = 4;
+			len++;
+			buf[len] = feature->df_type;
+			len++;
+			buf[len] = 1;
+			len++;
+		}
+	}
+
+	if (dccp->dccp_timestamp_echo != 0) {
+		uint32_t	elapsed;
+		int		elapsed_length;
+		clock_t		now;
+
+		buf[len] = DCCP_OPTION_TIMESTAMP_ECHO;
+		len++;
+		buf[len] = 10;
+		len++;
+
+		now = TICK_TO_MSEC(LBOLT_FASTPATH);
+		elapsed =  now - dccp->dccp_timestamp;
+
+
+		dccp->dccp_timestamp_echo = 0;
+	}
+
+	if (len != 0) {
+		total_len = ((len + (4 - 1)) / 4) * 4;
+		options = kmem_zalloc(total_len, KM_SLEEP);
+		if (options == NULL) {
+			cmn_err(CE_NOTE, "kmem_zalloc failed");
+			return (ENOMEM);
+		}
+		memcpy(options, buf, len);
+	}
+
+	*opt = options;
+	*opt_len = len;
+
+	return (0);
+}
